- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Slots | Signals | Public Member Functions | Properties | Friends

# MediaObject Class Reference

Search for all occurrences

## Detailed Description

Interface for media playback of a given URL.

This class is the most important class in Phonon. Use it to open a media file at an arbitrary location, a CD or DVD or to stream media data from the application to the backend.

This class controls the state (play, pause, stop, seek) and you can use it to get a lot of information about the media data.

Notice that most functions of this class are asynchronous. That means if you call play() the object only starts playing when the stateChanged() signal tells you that the object changed into PlayingState. The states you can expect are documented for those methods.

A common usage example is the following:

     media = new MediaObject(this);
     connect(media, SIGNAL(finished()), SLOT(slotFinished());
     media->setCurrentSource("/home/username/music/filename.ogg");
     media->play();

If you want to play more than one media file (one after another) you can either tell MediaObject about all those files

     media->setCurrentSource(":/sounds/startsound.ogg");
     media->enqueue("/home/username/music/song.mp3");
     media->enqueue(":/sounds/endsound.ogg");

or provide the next file just in time:

       media->setCurrentSource(":/sounds/startsound.ogg");
       connect(media, SIGNAL(aboutToFinish()), SLOT(enqueueNextSource()));
     }

     void enqueueNextSource()
     {
       media->enqueue("/home/username/music/song.mp3");
     }

Author:
  Matthias Kretz <kretz@kde.org>

Definition at line 85 of file mediaobject.h.

`#include <Phonon/MediaObject>`

Inheritance diagram for MediaObject:
[legend]

List of all members.

## Public Slots
void | setTickInterval (qint32 newTickInterval)
void | play ()
| Requests playback of the media data to start.
void | pause ()
| Requests playback to pause.
void | stop ()
| Requests playback to stop.
void | seek (qint64 time)
| Requests a seek to the time indicated.
void | clear ()
| Stops and removes all playing and enqueued media sources.
## Signals
void | stateChanged (Phonon::State newstate, Phonon::State oldstate)
| Emitted when the state of the MediaObject has changed.
void | tick (qint64 time)
| This signal gets emitted every tickInterval milliseconds.
void | metaDataChanged ()
| This signal is emitted whenever the audio/video data that is being played is associated with new meta data.
void | seekableChanged (bool isSeekable)
| Emitted whenever the return value of isSeekable() changes.
void | hasVideoChanged (bool hasVideo)
| Emitted whenever the return value of hasVideo() changes.
void | bufferStatus (int percentFilled)
| Tells about the status of the buffer.
void | finished ()
| Emitted when the object has finished playback.
void | currentSourceChanged (const Phonon::MediaSource &newSource)
| Emitted when the MediaObject makes a transition to the next MediaSource in the queue().
void | aboutToFinish ()
| Emitted before the playback of the whole queue stops.
void | prefinishMarkReached (qint32 msecToEnd)
| Emitted when there are only `msecToEnd` milliseconds left for playback.
void | totalTimeChanged (qint64 newTotalTime)
| This signal is emitted as soon as the total time of the media file is known or has changed.
## Public Member Functions
| ~MediaObject ()
| Destroys the MediaObject.
State | state () const
| Get the current state.
bool | hasVideo () const
| Check whether the media data includes a video stream.
bool | isSeekable () const
| Check whether the current media may be seeked.
qint32 | tickInterval () const
QStringList | metaData (const QString &key) const
| Returns the strings associated with the given `key`.
QStringList | metaData (Phonon::MetaData key) const
| Returns the strings associated with the given `key`.
QMultiMap< QString, QString > | metaData () const
| Returns all meta data.
QString | errorString () const
| Returns a human-readable description of the last error that occurred.
ErrorType | errorType () const
| Tells your program what to do about the error.
MediaSource | currentSource () const
| Returns the current media source.
void | setCurrentSource (const MediaSource &source)
| Set the media source the MediaObject should use.
QList< MediaSource > | queue () const
| Returns the queued media sources.
void | setQueue (const QList< MediaSource > &sources)
| Set the MediaSources to play when the current media has finished.
void | setQueue (const QList< QUrl > &urls)
| Set the MediaSources to play when the current media has finished.
void | enqueue (const MediaSource &source)
| Appends one source to the queue.
void | enqueue (const QList< MediaSource > &sources)
| Appends multiple sources to the queue.
void | enqueue (const QList< QUrl > &urls)
| Appends multiple sources to the queue.
void | clearQueue ()
| Clears the queue of sources.
qint64 | currentTime () const
| Get the current time (in milliseconds) of the file currently being played.
qint64 | totalTime () const
| Get the total time (in milliseconds) of the file currently being played.
qint64 | remainingTime () const
| Get the remaining time (in milliseconds) of the file currently being played.
qint32 | prefinishMark () const
void | setPrefinishMark (qint32 msecToEnd)
qint32 | transitionTime () const
void | setTransitionTime (qint32 msec)
## Properties
qint32 | transitionTime
| Defines the time between media sources.
qint32 | prefinishMark
| Get a signal before playback finishes.
qint32 | tickInterval
| The time interval in milliseconds between two ticks.
## Friends
class | FrontendInterfacePrivate

## Constructor & Destructor Documentation

~MediaObject | ( |  | ) |

Destroys the MediaObject.

## Member Function Documentation

State state | ( |  | ) | const

Search for all occurrences

Get the current state.

Returns:
  The state of the object.

See also:
  State
  stateChanged

bool hasVideo | ( |  | ) | const

Search for all occurrences

Check whether the media data includes a video stream.

Warning:
  This information cannot be known immediately. It is best to also listen to the hasVideoChanged signal.

       connect(media, SIGNAL(hasVideoChanged(bool)), hasVideoChanged(bool));
       media->setCurrentSource("somevideo.avi");
       media->hasVideo(); // returns false;
     }

     void hasVideoChanged(bool b)
     {
       // b == true
       media->hasVideo(); // returns true;
     }

Returns:
  `true` if the media contains video data. `false` otherwise.

See also:
  hasVideoChanged

bool isSeekable | ( |  | ) | const

Search for all occurrences

Check whether the current media may be seeked.

Warning:
  This information cannot be known immediately. It is best to also listen to the seekableChanged signal.

       connect(media, SIGNAL(seekableChanged(bool)), seekableChanged(bool));
       media->setCurrentSource("somevideo.avi");
       media->isSeekable(); // returns false;
     }

     void seekableChanged(bool b)
     {
       // b == true
       media->isSeekable(); // returns true;
     }

Returns:
  `true` when the current media may be seeked. `false` otherwise.

See also:
  seekableChanged()

qint32 tickInterval | ( |  | ) | const

Search for all occurrences

QStringList metaData | ( | const QString & | key | ) | const

Search for all occurrences

Returns the strings associated with the given `key`.

Backends should use the keys specified in the Ogg Vorbis documentation: http://xiph.org/vorbis/doc/v-comment.html

Therefore the following should work with every backend:

A typical usage looks like this:

     setMetaArtist (media->metaData("ARTIST"     ));
     setMetaAlbum  (media->metaData("ALBUM"      ));
     setMetaTitle  (media->metaData("TITLE"      ));
     setMetaDate   (media->metaData("DATE"       ));
     setMetaGenre  (media->metaData("GENRE"      ));
     setMetaTrack  (media->metaData("TRACKNUMBER"));
     setMetaComment(media->metaData("DESCRIPTION"));

For Audio CDs you can query

     metaData("MUSICBRAINZ_DISCID");

to get a DiscID hash that you can use with the MusicBrainz service: http://musicbrainz.org/doc/ClientHOWTO

QStringList metaData | ( | Phonon::MetaData | key | ) | const

Search for all occurrences

Returns the strings associated with the given `key`.

Same as above except that the keys are defined in the Phonon::MetaData enum.

QMultiMap<QString, QString> metaData | ( |  | ) | const

Search for all occurrences

Returns all meta data.

QString errorString | ( |  | ) | const

Search for all occurrences

Returns a human-readable description of the last error that occurred.

ErrorType errorType | ( |  | ) | const

Search for all occurrences

Tells your program what to do about the error.

See also:
  Phonon::ErrorType

MediaSource currentSource | ( |  | ) | const

Search for all occurrences

Returns the current media source.

See also:
  setCurrentSource

void setCurrentSource | ( | const MediaSource & | source | ) |

Search for all occurrences

Set the media source the MediaObject should use.

Parameters:

  source | The MediaSource object to the media data. You can just as well use a QUrl or QString (for a local file) here. Setting an empty (invalid) source, will stop and remove the current source.

     QUrl url("http://www.example.com/music.ogg");
     media->setCurrentSource(url);

See also:
  currentSource

QList<MediaSource> queue | ( |  | ) | const

Search for all occurrences

Returns the queued media sources.

This list does not include the current source (returned by currentSource).

void setQueue | ( | const QList< MediaSource > & | sources | ) |

Search for all occurrences

Set the MediaSources to play when the current media has finished.

This function will overwrite the current queue.

See also:
  clearQueue
  enqueue

void setQueue | ( | const QList< QUrl > & | urls | ) |

Search for all occurrences

Set the MediaSources to play when the current media has finished.

This function overwrites the current queue.

See also:
  clearQueue
  enqueue

void enqueue | ( | const MediaSource & | source | ) |

Search for all occurrences

Appends one source to the queue.

Use this function to provide the next source just in time after the aboutToFinish signal was emitted.

See also:
  aboutToFinish
  setQueue
  clearQueue

void enqueue | ( | const QList< MediaSource > & | sources | ) |

Search for all occurrences

Appends multiple sources to the queue.

See also:
  setQueue
  clearQueue

void enqueue | ( | const QList< QUrl > & | urls | ) |

Search for all occurrences

Appends multiple sources to the queue.

See also:
  setQueue
  clearQueue

void clearQueue | ( |  | ) |

Search for all occurrences

Clears the queue of sources.

qint64 currentTime | ( |  | ) | const

Search for all occurrences

Get the current time (in milliseconds) of the file currently being played.

Returns:
  The current time in milliseconds.

See also:
  tick

qint64 totalTime | ( |  | ) | const

Search for all occurrences

Get the total time (in milliseconds) of the file currently being played.

Returns:
  The total time in milliseconds.

See also:
  totalTimeChanged

qint64 remainingTime | ( |  | ) | const

Search for all occurrences

Get the remaining time (in milliseconds) of the file currently being played.

Returns:
  The remaining time in milliseconds.

qint32 prefinishMark | ( |  | ) | const

Search for all occurrences

void setPrefinishMark | ( | qint32 | msecToEnd | ) |

Search for all occurrences

qint32 transitionTime | ( |  | ) | const

Search for all occurrences

void setTransitionTime | ( | qint32 | msec | ) |

Search for all occurrences

void setTickInterval | ( | qint32 | newTickInterval | ) | `[slot]`

Search for all occurrences

void play | ( |  | ) | `[slot]`

Search for all occurrences

Requests playback of the media data to start.

Playback only starts when stateChanged() signals that it goes into PlayingState, though.

Possible states right after this call:
  - BufferingState
  - PlayingState
  - ErrorState

void pause | ( |  | ) | `[slot]`

Search for all occurrences

Requests playback to pause.

If it was paused before nothing changes.

Possible states right after this call:
  - PlayingState
  - PausedState
  - ErrorState

void stop | ( |  | ) | `[slot]`

Search for all occurrences

Requests playback to stop.

If it was stopped before nothing changes.

Possible states right after this call:
  - the state it was in before (e.g. PlayingState)
  - StoppedState
  - ErrorState

void seek | ( | qint64 | time | ) | `[slot]`

Search for all occurrences

Requests a seek to the time indicated.

You can only seek if state() == PlayingState, BufferingState or PausedState.

The call is asynchronous, so currentTime can still be the old value right after this method was called. If all you need is a slider that shows the current position and allows the user to seek use the class SeekSlider.

Parameters:

  time | The time in milliseconds where to continue playing.

Possible states right after this call:
  - BufferingState
  - PlayingState
  - ErrorState

See also:
  SeekSlider

void clear | ( |  | ) | `[slot]`

Search for all occurrences

Stops and removes all playing and enqueued media sources.

See also:
  setCurrentSource

void stateChanged | ( | Phonon::State | newstate,
|  | Phonon::State | oldstate
| ) |  | `[signal]`

Search for all occurrences

Emitted when the state of the MediaObject has changed.

Parameters:

  newstate | The state the Player is in now.
  oldstate | The state the Player was in before.

void tick | ( | qint64 | time | ) | `[signal]`

Search for all occurrences

This signal gets emitted every tickInterval milliseconds.

Parameters:

  time | The position of the media file in milliseconds.

See also:
  setTickInterval, tickInterval

void metaDataChanged | ( |  | ) | `[signal]`

Search for all occurrences

This signal is emitted whenever the audio/video data that is being played is associated with new meta data.

E.g. for radio streams this happens when the next song is played.

You can get the new meta data with the metaData methods.

void seekableChanged | ( | bool | isSeekable | ) | `[signal]`

Search for all occurrences

Emitted whenever the return value of isSeekable() changes.

Normally you'll check isSeekable() first and then let this signal tell you whether seeking is possible now or not. That way you don't have to poll isSeekable().

Parameters:

  isSeekable | `true` if the stream is seekable (i.e. calling seek() works) `false` if the stream is not seekable (i.e. all calls to seek() will be ignored)

void hasVideoChanged | ( | bool | hasVideo | ) | `[signal]`

Search for all occurrences

Emitted whenever the return value of hasVideo() changes.

Normally you'll check hasVideo() first and then let this signal tell you whether video is available now or not. That way you don't have to poll hasVideo().

Parameters:

  hasVideo | `true` The stream contains video and adding a VideoWidget will show a video. `false` There is no video data in the stream and adding a VideoWidget will show an empty (black) VideoWidget.

void bufferStatus | ( | int | percentFilled | ) | `[signal]`

Search for all occurrences

Tells about the status of the buffer.

You can use this signal to show a progress bar to the user when in BufferingState:

     progressBar->setRange(0, 100); // this is the default
     connect(media, SIGNAL(bufferStatus(int)), progressBar, SLOT(setValue(int)));

Parameters:

  percentFilled | A number between 0 and 100 telling you how much the buffer is filled.

void finished | ( |  | ) | `[signal]`

Search for all occurrences

Emitted when the object has finished playback.

It is not emitted if you call stop(), pause() or load(), but only on end-of-queue or a critical error.

Warning:
  This signal is not emitted when the current source has finished and there's another source in the queue. It is only emitted when the queue is empty.

See also:
  currentSourceChanged
  aboutToFinish
  prefinishMarkReached

void currentSourceChanged | ( | const Phonon::MediaSource & | newSource | ) | `[signal]`

Search for all occurrences

Emitted when the MediaObject makes a transition to the next MediaSource in the queue().

In other words, it is emitted when an individual MediaSource is finished.

Parameters:

  newSource | The source that starts to play at the time the signal is emitted.

void aboutToFinish | ( |  | ) | `[signal]`

Search for all occurrences

Emitted before the playback of the whole queue stops.

When this signal is emitted you still have time to provide the next MediaSource (using enqueue()) so that playback continues.

This signal can be used to provide the next MediaSource just in time for the transition still to work.

See also:
  enqueue

void prefinishMarkReached | ( | qint32 | msecToEnd | ) | `[signal]`

Search for all occurrences

Emitted when there are only `msecToEnd` milliseconds left for playback.

Parameters:

  msecToEnd | The remaining time until the playback queue finishes.

Warning:
  This signal is not emitted when there is another source in the queue. It is only emitted when the queue is empty.

See also:
  setPrefinishMark
  prefinishMark
  aboutToFinish
  finished

void totalTimeChanged | ( | qint64 | newTotalTime | ) | `[signal]`

Search for all occurrences

This signal is emitted as soon as the total time of the media file is known or has changed.

For most non-local media data the total time of the media can only be known after some time. Initially the totalTime function can not return useful information. You have to wait for this signal to know the real total time.

Parameters:

  newTotalTime | The length of the media file in milliseconds.

See also:
  totalTime

## Friends And Related Function Documentation

friend class FrontendInterfacePrivate `[friend]`

Search for all occurrences

Definition at line 87 of file mediaobject.h.

## Property Documentation

qint32 transitionTime `[read, write]`

Search for all occurrences

Defines the time between media sources.

A positive transition time defines a gap of silence between queued media sources.

A transition time of 0 ms requests gapless playback (sample precise queueing of the next source).

A negative transition time defines a crossfade between the queued media sources.

Defaults to 0 (gapless playback).

Warning:
  This feature might not work reliably on every platform.

Definition at line 107 of file mediaobject.h.

qint32 prefinishMark `[read, write]`

Search for all occurrences

Get a signal before playback finishes.

This property specifies the time in milliseconds the prefinishMarkReached signal is emitted before the playback finishes. A value of `0` disables the signal.

Defaults to `0` (disabled).

Warning:
  For some media data the total time cannot be determined accurately, therefore the accuracy of the prefinishMarkReached signal can be bad sometimes. Still, it is better to use this method than to look at totalTime() and currentTime() to emulate the behaviour because the backend might have more information available than your application does through totalTime and currentTime.

See also:
  prefinishMarkReached

Definition at line 128 of file mediaobject.h.

qint32 tickInterval `[read, write]`

Search for all occurrences

The time interval in milliseconds between two ticks.

The tick interval is the time that elapses between the emission of two tick signals. If you set the interval to `0` the tick signal gets disabled.

Defaults to `0` (disabled).

Warning:
  The back-end is free to choose a different tick interval close to what you asked for. This means that the following code may fail:

       int x = 200;
       media->setTickInterval(x);
       Q_ASSERT(x == producer->tickInterval());

  On the other hand the following is guaranteed:

       int x = 200;
       media->setTickInterval(x);
       Q_ASSERT(x >= producer->tickInterval() &&
                x <= 2 * producer->tickInterval());

See also:
  tick

Definition at line 155 of file mediaobject.h.

The documentation for this class was generated from the following file:

- phonon/mediaobject.h

MediaObject MediaObject MediaObject MediaObject MediaObject MediaObject MediaObject MediaObject MediaObject MediaObject
MediaObject MediaObject MediaObject MediaObject MediaObject MediaObject MediaObject MediaObject MediaObject MediaObject